{ ****************************************************************
  Typ              :  Hauptformular
  Autor            :  Andreas Kosch
  Compiler         :  Delphi 4.02 CSS
  Betriebssystem   :  Windows 98
  Beschreibung     :  BDE-Monitor als Ersatz fr den in der
                      Professional-Version von Delphi fehlenden
                      SQL-Monitor.
 **************************************************************** }

unit BDEMonitorFrmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, StdCtrls, ActnList, ImgList,
  ComCtrls, Menus, ToolWin, ExtCtrls, DBCtrls;

type
  TFormMain = class(TForm)
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    MFExit: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageListE: TImageList;
    ImageListD: TImageList;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActionList1: TActionList;
    ActionLogin: TAction;
    ActionLogout: TAction;
    ActionQueryOpen: TAction;
    DBNavigator1: TDBNavigator;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    DBGrid1: TDBGrid;
    MemoBDEMon: TMemo;
    ListBoxVCLAction: TListBox;
    ActionExit: TAction;
    ActionQueryClose: TAction;
    MDatabase: TMenuItem;
    Datenbankverbindungherstellen1: TMenuItem;
    Datenbankverbindungtrennen1: TMenuItem;
    N1: TMenuItem;
    SELECTAbfragestarten1: TMenuItem;
    SELECTAbfrageschlieen1: TMenuItem;
    procedure ActionLogoutExecute(Sender: TObject);
    procedure ActionLoginExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure ActionQueryOpenExecute(Sender: TObject);
    procedure ActionQueryCloseExecute(Sender: TObject);
  private
    { Private-Deklarationen }
    FLogin : Boolean;
  public
    { Public-Deklarationen }
    procedure LogVCLAction(LogMsg: String);
    procedure LogBDEMonitor(LogMsg: String);
  end;

var
  FormMain: TFormMain;

implementation

uses BDEMonitor_DM;

{$R *.DFM}

procedure TFormMain.FormCreate(Sender: TObject);
begin
  FLogin := False;
end;

// Button erst freischalten, wenn DB-Verbindung aktiv ist

procedure TFormMain.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
begin
  ActionLogin.Enabled := not FLogin;
  ActionLogout.Enabled := FLogin;
  ActionQueryOpen.Enabled := FLogin;
  ActionQueryClose.Enabled := FLogin;
  Handled := True;
end;

procedure TFormMain.ActionLoginExecute(Sender: TObject);
begin
  DM.DBLogin;
  FLogin := True;
  StatusBar1.Panels[0].Text := 'Login';
end;

procedure TFormMain.ActionLogoutExecute(Sender: TObject);
begin
  DM.DBLogout;
  FLogin := False;
  StatusBar1.Panels[0].Text := '';
end;

procedure TFormMain.ActionExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.ActionQueryOpenExecute(Sender: TObject);
begin
  DM.DBQuery(True);
  StatusBar1.Panels[2].Text := 'SELECT-Abfrage ist aktiv.'
end;

procedure TFormMain.ActionQueryCloseExecute(Sender: TObject);
begin
  DM.DBQuery(False);
  StatusBar1.Panels[2].Text := ''
end;

procedure TFormMain.LogBDEMonitor(LogMsg: String);
begin
  MemoBDEMon.Lines.Add(LogMsg);
end;

procedure TFormMain.LogVCLAction(LogMsg: String);
begin
  ListBoxVCLAction.Items.Add(LogMsg);
end;

end.
