{ ****************************************************************
  Typ              :  Datenmodul
  Autor            :  Andreas Kosch
  Compiler         :  Delphi 4.02 CSS
  Betriebssystem   :  Windows 98
  Beschreibung     :  BDE-Monitor als Ersatz fr den in der
                      Professional-Version von Delphi fehlenden
                      SQL-Monitor.
 **************************************************************** }

unit BDEMonitor_DM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, SQLMonitor;

type
  TDM = class(TDataModule)
    Database1: TDatabase;
    Query1: TQuery;
    Query1ORTID: TIntegerField;
    Query1PLZ: TStringField;
    Query1ORT: TStringField;
    DataSource1: TDataSource;
    procedure Query1BeforeOpen(DataSet: TDataSet);
    procedure Query1AfterOpen(DataSet: TDataSet);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DataSource1StateChange(Sender: TObject);
    procedure DataSource1UpdateData(Sender: TObject);
    procedure Query1AfterScroll(DataSet: TDataSet);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure DBLogin;
    procedure DBLogout;
    procedure DBQuery(bOpen : Boolean);
  end;

var
  DM: TDM;

implementation

{$R *.DFM}

uses BDEMonitorFrmMain;

{ TDM }

procedure TDM.DBLogin;
begin
  Database1.Connected := True;
  FormMain.LogVCLAction('DB-Login');
end;

procedure TDM.DBLogout;
begin
  Database1.Connected := False;
  FormMain.LogVCLAction('DB-Logout');
end;

procedure TDM.DBQuery(bOpen: Boolean);
begin
  Query1.Active := bOpen;
end;

procedure TDM.Query1BeforeOpen(DataSet: TDataSet);
begin
  FormMain.LogVCLAction('TQuery.BeforeOpen');
end;

procedure TDM.Query1AfterOpen(DataSet: TDataSet);
begin
  FormMain.LogVCLAction('TQuery.AfterOpen');
end;

procedure TDM.Query1AfterScroll(DataSet: TDataSet);
begin
  FormMain.LogVCLAction('TQuery.AfterScroll');
end;

procedure TDM.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  FormMain.LogVCLAction('TDataSource.OnDataChange');
end;

procedure TDM.DataSource1StateChange(Sender: TObject);
begin
  FormMain.LogVCLAction('TDataSource.OnStateChange');
end;

procedure TDM.DataSource1UpdateData(Sender: TObject);
begin
  FormMain.LogVCLAction('TDataSource.OnUpdateChange');
end;

end.
