{ ****************************************************************
  Typ              :  Tool-Unit
  Autor            :  Andreas Kosch
  Compiler         :  Delphi 4.02 CSS
  Betriebssystem   :  Windows 98
  Beschreibung     :  Home-made SQL-Monitor nutzt die Win32-API-
                      Funktion OutputDebugString, um einen Teil
                      der Funktionalitt des SQL-Monitors in die
                      eigene Anwendung einzubauen.
 **************************************************************** }

unit SQLMonitor;

interface

uses
  Windows, Classes, SysUtils, DB, DBTables, BDE,Dialogs;

type
  // Struktur siehe BDE32.HLP cbTRACE:
  //  typedef struct              // trace callback info
  //   { TRACECat  eTraceCat;     // trace category
  //     UINT16    uTotalMsgLen;  // total message length
  //     CHAR      pszTrace[];    // trace string (recommended size = DBIMAXTRACELEN (8192))
  //   } TRACEDesc;
  //
  // Deklaration in BDE.INT:
  //  TRACEDesc = packed record             { trace callback info }
  //    eTraceCat       : TRACECat;
  //    uTotalMsgLen    : Word;
  //    pszTrace        : array [0..0] of Char;
  //  end;
  AllocTRACEDesc = packed record
    eTraceCat    : TRACECat;
    uTotalMsgLen : Word;
    pszTrace     : array [0..DBIMaxTraceLen] of Char;
  end;

function BDETraceCB(ecbType: CBType;
                    iClientData: Integer;
                    CbInfo: Pointer): CBRType; stdcall;

implementation

uses BDEMonitorFrmMain;

var
  CbBuf : AllocTRACEDesc;

procedure SetLogMsgText(sMsgTxt: String);
begin
   OutputDebugString(PChar(sMsgTxt));
  FormMain.LogBDEMonitor(sMsgTxt);
end;

{
  BDE-Callbackfunktion
}

function BDETraceCB(ecbType: CBType;
                    iClientData:Integer;
                    CbInfo:Pointer): CBRType;
begin
  SetLogMsgText(CbBuf.pszTrace);
  Result := cbrCONTINUE;
end;

procedure TraceStart;
begin
  DbiInit(nil);
  Session.TraceFlags := [tfQPrepare, tfQExecute, tfError, tfStmt, tfConnect,
                         tfTransact, tfBlob, tfMisc, tfVendor];
  Check(DbiRegisterCallback(nil, cbTrace, 0, SizeOf(CbBuf), @CbBuf, @BDETraceCB));
end;

procedure TraceDone;
begin
  DbiRegisterCallBack(nil, cbTrace, 0, SizeOf(CbBuf), @CbBuf, nil);
  DbiExit;
end;

initialization
  TraceStart;

finalization
  TraceDone;

end.
